io.vertx.core.net

## Interface NetSocket

- All Superinterfaces:
    ReadStream<Buffer>, StreamBase, WriteStream<Buffer>

      public interface NetSocket
      extends ReadStream<Buffer>, WriteStream<Buffer>

  Represents a socket-like interface to a TCP connection on either the client or the server side.

  Instances of this class are created on the client side by an `NetClient` when a connection to a server is made, or on the server side by a `NetServer` when a server accepts a connection.

  It implements both `ReadStream` and `WriteStream` so it can be used with `Pipe` to pipe data with flow control.

  Author:
    Tim Fox

- - ### Method Summary

    All Methods Instance Methods Abstract Methods Default Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `String` | `applicationLayerProtocol()`
    `Future<Void>` | `close()` Close the NetSocket
    `void` | `close(Handler<AsyncResult<Void>> handler)` Close the NetSocket and notify the `handler` when the operation completes.
    `NetSocket` | `closeHandler(Handler<Void> handler)` Set a handler that will be called when the NetSocket is closed
    `NetSocket` | `drainHandler(Handler<Void> handler)` Set a drain handler on the stream.
    `Future<Void>` | `end()` Calls `close()`
    `void` | `end(Handler<AsyncResult<Void>> handler)` Calls `end()`.
    `NetSocket` | `endHandler(Handler<Void> endHandler)` Set an end handler.
    `NetSocket` | `exceptionHandler(Handler<Throwable> handler)` Set an exception handler on the read stream.
    `NetSocket` | `fetch(long amount)` Fetch the specified `amount` of elements.
    `NetSocket` | `handler(Handler<Buffer> handler)` Set a data handler.
    `String` | `indicatedServerName()` Returns the SNI server name presented during the SSL handshake by the client.
    `boolean` | `isSsl()`
    `SocketAddress` | `localAddress()`
    `SocketAddress` | `localAddress(boolean real)` Like `localAddress()` ()} but returns the server local address when `real` is `true`
    `NetSocket` | `pause()` Pause the `ReadStream`, it sets the buffer in `fetch` mode and clears the actual demand.
    `X509Certificate[]` | `peerCertificateChain()` Deprecated. instead use `peerCertificates()` or `sslSession()`
    `List<Certificate>` | `peerCertificates()`
    `SocketAddress` | `remoteAddress()`
    `SocketAddress` | `remoteAddress(boolean real)` Like `remoteAddress()` but returns the proxy remote address when `real` is `true`
    `NetSocket` | `resume()` Resume reading, and sets the buffer in `flowing` mode.
    `default Future<Void>` | `sendFile(String filename)` Tell the operating system to stream a file as specified by `filename` directly from disk to the outgoing connection, bypassing userspace altogether (where supported by the underlying operating system.
    `default NetSocket` | `sendFile(String filename, Handler<AsyncResult<Void>> resultHandler)` Same as `sendFile(String)` but also takes a handler that will be called when the send has completed or a failure has occurred
    `default Future<Void>` | `sendFile(String filename, long offset)` Tell the operating system to stream a file as specified by `filename` directly from disk to the outgoing connection, bypassing userspace altogether (where supported by the underlying operating system.
    `default NetSocket` | `sendFile(String filename, long offset, Handler<AsyncResult<Void>> resultHandler)` Same as `sendFile(String, long)` but also takes a handler that will be called when the send has completed or a failure has occurred
    `Future<Void>` | `sendFile(String filename, long offset, long length)` Tell the operating system to stream a file as specified by `filename` directly from disk to the outgoing connection, bypassing userspace altogether (where supported by the underlying operating system.
    `NetSocket` | `sendFile(String filename, long offset, long length, Handler<AsyncResult<Void>> resultHandler)` Same as `sendFile(String, long, long)` but also takes a handler that will be called when the send has completed or a failure has occurred
    `NetSocket` | `setWriteQueueMaxSize(int maxSize)` Set the maximum size of the write queue to `maxSize`.
    `SSLSession` | `sslSession()`
    `Future<Void>` | `upgradeToSsl()` Like `upgradeToSsl(Handler)` but returns a `Future` of the asynchronous result
    `NetSocket` | `upgradeToSsl(Handler<AsyncResult<Void>> handler)` Upgrade channel to use SSL/TLS.
    `Future<Void>` | `upgradeToSsl(String serverName)` Like `upgradeToSsl(String, Handler)` but returns a `Future` of the asynchronous result
    `NetSocket` | `upgradeToSsl(String serverName, Handler<AsyncResult<Void>> handler)` Upgrade channel to use SSL/TLS.
    `void` | `write(Buffer message, Handler<AsyncResult<Void>> handler)` Like `WriteStream.write(Object)` but with an `handler` called when the message has been written or failed to be written.
    `Future<Void>` | `write(String str)` Write a `String` to the connection, encoded in UTF-8.
    `void` | `write(String str, Handler<AsyncResult<Void>> handler)` Same as `write(String)` but with an `handler` called when the operation completes
    `Future<Void>` | `write(String str, String enc)` Write a `String` to the connection, encoded using the encoding `enc`.
    `void` | `write(String str, String enc, Handler<AsyncResult<Void>> handler)` Same as `write(String, String)` but with an `handler` called when the operation completes
    `String` | `writeHandlerID()` When a `NetSocket` is created, it may register an event handler with the event bus, the ID of that handler is given by `writeHandlerID`.

    - ### Methods inherited from interface io.vertx.core.streams.ReadStream

      `pipe, pipeTo, pipeTo`

    - ### Methods inherited from interface io.vertx.core.streams.WriteStream

      `end, end, write, writeQueueFull`

- - ### Method Detail

    - #### exceptionHandler

          NetSocket exceptionHandler(Handler<Throwable> handler)

      Description copied from interface: `ReadStream`
      Set an exception handler on the read stream.
      Specified by:
        `exceptionHandler` in interface `ReadStream<Buffer>`
      Specified by:
        `exceptionHandler` in interface `StreamBase`
      Specified by:
        `exceptionHandler` in interface `WriteStream<Buffer>`
      Parameters:
        `handler` - the exception handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### handler

          NetSocket handler(Handler<Buffer> handler)

      Description copied from interface: `ReadStream`
      Set a data handler. As data is read, the handler will be called with the data.
      Specified by:
        `handler` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### pause

          NetSocket pause()

      Description copied from interface: `ReadStream`
      Pause the `ReadStream`, it sets the buffer in `fetch` mode and clears the actual demand.

      While it's paused, no data will be sent to the data `handler`.

      Specified by:
        `pause` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### resume

          NetSocket resume()

      Description copied from interface: `ReadStream`
      Resume reading, and sets the buffer in `flowing` mode.

      If the `ReadStream` has been paused, reading will recommence on it.
      Specified by:
        `resume` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### fetch

          NetSocket fetch(long amount)

      Description copied from interface: `ReadStream`
      Fetch the specified `amount` of elements. If the `ReadStream` has been paused, reading will recommence with the specified `amount` of items, otherwise the specified `amount` will be added to the current stream demand.
      Specified by:
        `fetch` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### endHandler

          NetSocket endHandler(Handler<Void> endHandler)

      Set an end handler. Once the stream has ended, and there is no more data to be read, this handler will be called.

      This handler might be called after the close handler when the socket is paused and there are still buffers to deliver.

      Specified by:
        `endHandler` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### setWriteQueueMaxSize

          NetSocket setWriteQueueMaxSize(int maxSize)

      Description copied from interface: `WriteStream`
      Set the maximum size of the write queue to `maxSize`. You will still be able to write to the stream even if there is more than `maxSize` items in the write queue. This is used as an indicator by classes such as `Pipe` to provide flow control.

      The value is defined by the implementation of the stream, e.g in bytes for a `NetSocket`, etc...
      Specified by:
        `setWriteQueueMaxSize` in interface `WriteStream<Buffer>`
      Parameters:
        `maxSize` - the max size of the write stream
      Returns:
        a reference to this, so the API can be used fluently

    - #### drainHandler

          NetSocket drainHandler(Handler<Void> handler)

      Description copied from interface: `WriteStream`
      Set a drain handler on the stream. If the write queue is full, then the handler will be called when the write queue is ready to accept buffers again. See `Pipe` for an example of this being used.

      The stream implementation defines when the drain handler, for example it could be when the queue size has been reduced to `maxSize / 2`.

      Specified by:
        `drainHandler` in interface `WriteStream<Buffer>`
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### writeHandlerID

          String writeHandlerID()

      When a `NetSocket` is created, it may register an event handler with the event bus, the ID of that handler is given by `writeHandlerID`.

      By default, no handler is registered, the feature must be enabled via `NetClientOptions.setRegisterWriteHandler(boolean)` or `NetServerOptions.setRegisterWriteHandler(boolean)`.

      Given this ID, a different event loop can send a buffer to that event handler using the event bus and that buffer will be received by this instance in its own event loop and written to the underlying connection. This allows you to write data to other connections which are owned by different event loops.

      Returns:
        the write handler ID
      See Also:
        `NetClientOptions.setRegisterWriteHandler(boolean)`, `NetServerOptions.setRegisterWriteHandler(boolean)`

    - #### write

          void write(String str,
                     Handler<AsyncResult<Void>> handler)

      Same as `write(String)` but with an `handler` called when the operation completes

    - #### write

          Future<Void> write(String str)

      Write a `String` to the connection, encoded in UTF-8.
      Parameters:
        `str` - the string to write
      Returns:
        a future result of the write

    - #### write

          void write(String str,
                     String enc,
                     Handler<AsyncResult<Void>> handler)

      Same as `write(String, String)` but with an `handler` called when the operation completes

    - #### write

          Future<Void> write(String str,
                             String enc)

      Write a `String` to the connection, encoded using the encoding `enc`.
      Parameters:
        `str` - the string to write
        `enc` - the encoding to use
      Returns:
        a future completed with the result

    - #### write

          void write(Buffer message,
                     Handler<AsyncResult<Void>> handler)

      Like `WriteStream.write(Object)` but with an `handler` called when the message has been written or failed to be written.
      Specified by:
        `write` in interface `WriteStream<Buffer>`

    - #### sendFile

          default Future<Void> sendFile(String filename)

      Tell the operating system to stream a file as specified by `filename` directly from disk to the outgoing connection, bypassing userspace altogether (where supported by the underlying operating system. This is a very efficient way to stream files.
      Parameters:
        `filename` - file name of the file to send
      Returns:
        a future result of the send operation

    - #### sendFile

          default Future<Void> sendFile(String filename,
                                        long offset)

      Tell the operating system to stream a file as specified by `filename` directly from disk to the outgoing connection, bypassing userspace altogether (where supported by the underlying operating system. This is a very efficient way to stream files.
      Parameters:
        `filename` - file name of the file to send
        `offset` - offset
      Returns:
        a future result of the send operation

    - #### sendFile

          Future<Void> sendFile(String filename,
                                long offset,
                                long length)

      Tell the operating system to stream a file as specified by `filename` directly from disk to the outgoing connection, bypassing userspace altogether (where supported by the underlying operating system. This is a very efficient way to stream files.
      Parameters:
        `filename` - file name of the file to send
        `offset` - offset
        `length` - length
      Returns:
        a future result of the send operation

    - #### sendFile

          default NetSocket sendFile(String filename,
                                     Handler<AsyncResult<Void>> resultHandler)

      Same as `sendFile(String)` but also takes a handler that will be called when the send has completed or a failure has occurred
      Parameters:
        `filename` - file name of the file to send
        `resultHandler` - handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### sendFile

          default NetSocket sendFile(String filename,
                                     long offset,
                                     Handler<AsyncResult<Void>> resultHandler)

      Same as `sendFile(String, long)` but also takes a handler that will be called when the send has completed or a failure has occurred
      Parameters:
        `filename` - file name of the file to send
        `offset` - offset
        `resultHandler` - handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### sendFile

          NetSocket sendFile(String filename,
                             long offset,
                             long length,
                             Handler<AsyncResult<Void>> resultHandler)

      Same as `sendFile(String, long, long)` but also takes a handler that will be called when the send has completed or a failure has occurred
      Parameters:
        `filename` - file name of the file to send
        `offset` - offset
        `length` - length
        `resultHandler` - handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### remoteAddress

          SocketAddress remoteAddress()

      Returns:
        the remote address for this connection, possibly `null` (e.g a server bound on a domain socket). If `useProxyProtocol` is set to `true`, the address returned will be of the actual connecting client.

    - #### remoteAddress

          SocketAddress remoteAddress(boolean real)

      Like `remoteAddress()` but returns the proxy remote address when `real` is `true`

    - #### localAddress

          SocketAddress localAddress()

      Returns:
        the local address for this connection, possibly `null` (e.g a server bound on a domain socket) If `useProxyProtocol` is set to `true`, the address returned will be of the proxy.

    - #### localAddress

          SocketAddress localAddress(boolean real)

      Like `localAddress()` ()} but returns the server local address when `real` is `true`

    - #### end

          Future<Void> end()

      Calls `close()`
      Specified by:
        `end` in interface `WriteStream<Buffer>`
      Returns:
        a future completed with the result

    - #### end

          void end(Handler<AsyncResult<Void>> handler)

      Calls `end()`.
      Specified by:
        `end` in interface `WriteStream<Buffer>`

    - #### close

          Future<Void> close()

      Close the NetSocket
      Returns:
        a future completed with the result

    - #### close

          void close(Handler<AsyncResult<Void>> handler)

      Close the NetSocket and notify the `handler` when the operation completes.

    - #### closeHandler

          NetSocket closeHandler(Handler<Void> handler)

      Set a handler that will be called when the NetSocket is closed
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### upgradeToSsl

          NetSocket upgradeToSsl(Handler<AsyncResult<Void>> handler)

      Upgrade channel to use SSL/TLS. Be aware that for this to work SSL must be configured.
      Parameters:
        `handler` - the handler will be notified when it's upgraded
      Returns:
        a reference to this, so the API can be used fluently

    - #### upgradeToSsl

          Future<Void> upgradeToSsl()

      Like `upgradeToSsl(Handler)` but returns a `Future` of the asynchronous result

    - #### upgradeToSsl

          NetSocket upgradeToSsl(String serverName,
                                 Handler<AsyncResult<Void>> handler)

      Upgrade channel to use SSL/TLS. Be aware that for this to work SSL must be configured.
      Parameters:
        `serverName` - the server name
        `handler` - the handler will be notified when it's upgraded
      Returns:
        a reference to this, so the API can be used fluently

    - #### upgradeToSsl

          Future<Void> upgradeToSsl(String serverName)

      Like `upgradeToSsl(String, Handler)` but returns a `Future` of the asynchronous result

    - #### isSsl

          boolean isSsl()

      Returns:
        true if this `NetSocket` is encrypted via SSL/TLS.

    - #### sslSession

          SSLSession sslSession()

      Returns:
        SSLSession associated with the underlying socket. Returns null if connection is not SSL.
      See Also:
        `SSLSession`

    - #### peerCertificateChain

          @Deprecated
          X509Certificate[] peerCertificateChain()
                                                      throws SSLPeerUnverifiedException

      Deprecated. instead use `peerCertificates()` or `sslSession()`
      Returns:
        an ordered array of the peer certificates. Returns null if connection is not SSL.
      Throws:
        `SSLPeerUnverifiedException` - SSL peer's identity has not been verified.
      See Also:
        `SSLSession.getPeerCertificateChain()`, `sslSession()`

    - #### peerCertificates

          List<Certificate> peerCertificates()
                                      throws SSLPeerUnverifiedException

      Returns:
        an ordered list of the peer certificates. Returns null if connection is not SSL.
      Throws:
        `SSLPeerUnverifiedException` - SSL peer's identity has not been verified.
      See Also:
        `SSLSession.getPeerCertificateChain()`, `sslSession()`

    - #### indicatedServerName

          String indicatedServerName()

      Returns the SNI server name presented during the SSL handshake by the client.
      Returns:
        the indicated server name

    - #### applicationLayerProtocol

          String applicationLayerProtocol()

      Returns:
        the application-level protocol negotiated during the TLS handshake

Copyright © 2023 Eclipse. All rights reserved.